﻿using Infragistics.Windows;
using Infragistics.Windows.Controls;
using Infragistics.Windows.DockManager;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace XamDockManagerPaneSelection
{
    public class CustomContentPane : ContentPane
    {
        public CustomContentPane()
        {
            PreviewMouseUp += CustomContentPane_PreviewMouseUp;
        }

        bool broke = false;
        private void CustomContentPane_PreviewMouseUp(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            this.IsSelected = !this.IsSelected;

            if (this.PaneLocation == PaneLocation.Floating || this.PaneLocation == PaneLocation.FloatingOnly)
            {
                PaneToolWindow window = Utilities.GetAncestorFromType(this, typeof(PaneToolWindow), false) as PaneToolWindow;
                SplitPane pane = window.Pane;
                
                if (this.IsSelected)
                {
                    SolidColorBrush selectedBrush = App.Current.Resources["SelectionBrush"] as SolidColorBrush;
                    DockHelper.ColorToolWindow(window, selectedBrush, selectedBrush);
                }
                else
                {

                    foreach(var x in pane.Panes)
                    {
                        if(x is CustomContentPane)
                        {
                            if((x as CustomContentPane).IsSelected)
                            {
                                broke = true;
                                break;
                            }
                        }
                    }

                    if (!broke)
                    {
                        LinearGradientBrush captionBrush = App.Current.Resources["ToolWindowHeaderBrush"] as LinearGradientBrush;
                        SolidColorBrush borderBrush = App.Current.Resources["ToolWindowBorderBrush"] as SolidColorBrush;
                        DockHelper.ColorToolWindow(window, captionBrush, borderBrush);
                    }
                    else
                    {
                        broke = false;
                    }
                }
            }
        }

      

        public bool IsSelected
        {
            get { return (bool)GetValue(IsSelectedProperty); }
            set { SetValue(IsSelectedProperty, value); }
        }

        // Using a DependencyProperty as the backing store for IsSelected.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty IsSelectedProperty =
            DependencyProperty.Register("IsSelected", typeof(bool), typeof(CustomContentPane), new PropertyMetadata(false));
    }
}
